#!/usr/bin/perl
BEGIN {
    use lib './libs';
}
use Symbol;
use strict 'vars';
use strict 'subs';
use vars qw(
    $VERSION $SENDMAIL_METHOD $SENDMAIL $SMTPHOST $SMTPPORT $CLIENTDN
    $CONF_DIR $CONF_FILE $CONF_SUFFIX $HLOG_DIR $HLOG_MAX $ATTACH_DIR
    $ATTACH_URL $PLUG_DIR $DATA_DIR $DATA_DIR_CTRL $SYSTEM_IMAGE $HOME_URL
    $TMPL_PLACE $HOME_PATH $MAX_POST $PROGCODE $MAX_FILE_SIZE %OPERATORS
    %CHARSET $DNS_LOOKUP %RESERVE_CMD1 %RESERVE_CMD2 %FORM @INPUT_ORDER
    %SYS %CONF @WDAY_OF_WEEK $CHARSET $ERROR_MESSAGE $TIMEZONE
    $ERROR_ITEMS $FORM_NAME $FORM_URL $USER_AGENT $REMOTE_ADDR $SEPCHAR
    $REMOTE_HOST $IMAGE_URL %ITEM_PROPERTY %AUTO_VALUES $ENABLE_UPLOAD
    $ENABLE_SIMULATE $MAX_READ_SIZE @DENY_MAIL_ADDR %POP3_PARAM %SMTP_AUTH
    %AUTO_FUNC $AUTO_CORE %ERROR_MESSAGES
);
require 'jcode.pl';
use integer;

$VERSION = '4.3.4';
#------------------------------------------------------------------------
#                     ꤬ɬפʤ
#------------------------------------------------------------------------
#  ᡼ˡ (0: sendmail, 1: SMTP)
$SENDMAIL_METHOD = 0;
#
#  sendmailΥѥȥץ ($SENDMAIL_METHOD=0 ξ)
$SENDMAIL = '/usr/lib/sendmail -t -oi';
#
#  SMTP̾ȥݡֹ ($SENDMAIL_METHOD=1 ξ)
$SMTPHOST = 'mail.domain.name';
$SMTPPORT = 25;
$CLIENTDN = 'localhost';
#
#  POP before SMTPѻ ($SENDMAIL_METHOD=1 ξ)
%POP3_PARAM = ();
#
#  SMTP AUTHѤ ($SENDMAIL_METHOD=1 ξ)
%SMTP_AUTH = ();
#
#  ɸǼǥ쥯ȥ
$CONF_DIR = './conf';
#
#  ɸեե̾
$CONF_FILE = 'default.conf';
#
#  եե̾ʥԥꥪס
$CONF_SUFFIX = 'conf';
#
#  åѥǥ쥯ȥ
$HLOG_DIR = './logs';
#
#  źեǡ¸ǥ쥯ȥѥȻURL
$ATTACH_DIR = './attach';
$ATTACH_URL = './attach';
#
#  Plug-in⥸塼Ǽǥ쥯ȥ
$PLUG_DIR = './plugin';
#
#  ǥեȤѥǡ¸ǥ쥯ȥѥ(CSVϢ)
$DATA_DIR = './data';
#
#  ǡ¸
$DATA_DIR_CTRL = 0;
#
#    0: $TMPL_PLACE λ˽        ʥե̾Хѥġ
#    1: $TMPL_PLACE λ˽        ʥե̾ХѥԲġ
#    2: $DATA_DIR/ե̾/ ʲ˺ʥե̾ХѥԲġ
#
#  ƥ।᡼URL
$SYSTEM_IMAGE = '../../images';
#
#  ɥȥ롼URLꡣǸ"/"դʤ
$HOME_URL = 'https://www.ssl.jrao.ne.jp/';
#
#  եȥƥץ졼Ȥ־ꡣ
#    0: եѥǥ쥯ȥ֤
#    1: ƽФHTMLƱǥ쥯ȥ֤
$TMPL_PLACE = 0;
#
#  URLѥѴΤꡣǸ"/"դʤ
#    $TMPL_PLACE = 0 ξ
#       ץ֥ǥ쥯ȥ꤫ƥץ졼Ȥ֤롼ȥǥ쥯
#       ȥޤǤХѥޤХѥꤹ롣ºݤˤϤ
#       ꤷѥľΥե̾Υ֥ǥ쥯ȥʲ˳Ǽ롣
#    $TMPL_PLACE = 1 ξ
#       ץ֥ǥ쥯ȥ꤫ɥȥ롼ȤޤǤХѥ
#       ޤХѥꤹ롣
$HOME_PATH = '.';
#
#   $TMPL_PLACE=1ξλ  $HOME_PATH = '../..';
#
#  POSTǽʺϥ(ñ:Byte)
$MAX_POST = 50 * 1024;
#
#  ե륢åץɵǽ (0:̵, 1:ͭ)
$ENABLE_UPLOAD = 0;
#
#  åץɥե1濫κ祵(ñ:Byte)
$MAX_FILE_SIZE = 30 * 1024;
#
#  ⡼ȥۥ̾DNSȲǽʤ1
$DNS_LOOKUP = 0;
#
#  եॷߥ졼ǽ (0:̵, 1:ͭ)
$ENABLE_SIMULATE = 0;
#
#  ޥץ륻쥯Ȼѥ졼ʸɽϾ","Ѵ
$SEPCHAR = ",";
#
#  ޥѡȷPOSTREADХåեĹ̾Ͻס
$MAX_READ_SIZE = 16 * 1024;
#
#  ʸ(sjis/euc/jis/utf8) HTMLϥɤƱΨŪ
$PROGCODE = 'euc';
#
# ڽסCGIsetuidƼ¹ԤĶǤ 022/072/077 Ȥ롣
umask(000);
#
#  ॾܤʤGMT+9:00MIME.pmȤ⤢碌롣
$TIMEZONE = 9 * 60 * 60;
#
#  
@WDAY_OF_WEEK=qw(      );
#
#  եоݤΥ᡼륢ɥ쥹ݥɥᥤʸפȽ
@DENY_MAIL_ADDR = ();
#------------------------------------------------------------------------
#                   顼å
#------------------------------------------------------------------------
%ERROR_MESSAGES = (
    '01' =>'ʥꥯȤǤʤޤϥǡ¿ޤ',
    '02' => 'եĤʤޤϵҤ˸꤬ޤ',
    '03' => 'ƥץ졼ȤĤޤ',
    '04' => 'ȳǤޤ',
    '05' => 'ץͳ϶ػߤƤޤ',
    '06' => '᡼륢ɥ쥹Ǥ',
    '07' => 'ͱͽ֤򥪡Сޤ',
    '08' => 'γǧɬפǤ',
    '09' => 'ޤϡϢ³»Ǥ',
    '10' => 'ޥӥ֤Ǥ',
    '11' => 'Please enter or select the field(s) below:',
    '12' => '°顼ѿޤϱѿܤǤ',
    '13' => '°顼͹ܤޤϿԽܤǤ',
    '14' => 'Ҥ餬ʤΤϲǽǤ',
    '15' => '᡼륢ɥ쥹ηǤ',
    '16' => 'ꥰ롼פ˲­ޤ',
    '17' => 'ǧϹܤƤۤʤäƤޤ',
    '18' => '͹ܤϰϳǤ',
    '19' => '򥰥롼פ飱İʾޤϤɬפǤ',
    '20' => '򥰥롼פƤϤɬפǤ',
    '21' => '򥰥롼פ飱ĤΤޤϤƤ',
    '22' => 'եफϥǡޤ',
    '23' => 'եʼưԽˤ˸꤬ޤ<br>$FORM{_E_}',
    '24' => 'Ƥ¿뤫ޤɬפʸʲǤ',
    '25' => 'Υ᡼륢ɥ쥹ϻѤǤޤ',
    '26' => 'ʤΤϲǽǤ',
    '27' => 'ѤǤʤؿޤ<br>$FORM{_E_}',
    '70' => 'Plug-in⥸塼뤬Ĥʤޤϥ顼ޤ<br>$FORM{_E_}',
    '80' => '᡼ǥ顼ޤ',
    '90' => 'ߡΥեαѤߤƤޤ',
    '91' => 'եʥեϡˤǤޤ',
    '92' => 'Ͽ԰γǧ᡼ޤ',
    '99' => 'ƥ२顼Ǥ³ԤǤޤ',
);
#------------------------------------------------------------------------
#                   ꤬ɬפʤΤϤޤ
#------------------------------------------------------------------------
%CHARSET = (
    'sjis' => 'shift_jis',
    'euc'  => 'euc-jp',
    'jis'  => 'iso-2022-jp',
    'utf8' => 'utf-8',
);
%OPERATORS = (
    '=='  => 'eq',
    '!='  => 'ne',
    '<'   => 'lt',
    '<='  => 'le',
    '>'   => 'gt',
    '>='  => 'ge',
    '<=>' => 'cmp',
    'eq'  => 'eq',
    'ne'  => 'ne',
    'lt'  => 'lt',
    'le'  => 'le',
    'gt'  => 'gt',
    'ge'  => 'ge',
    'cmp' => 'cmp',
);
%RESERVE_CMD1 = (
    FORM_NAME       => '_form_name',
    FORM_URL        => '_form_url',
    CONTINUE        => '_continue',
    CONFCTRL        => '_confctrl',
    CHECK_ID        => '_check_id',
    SEND_TEST       => '_send_test',
    REPLY_TEST      => '_reply_test',
    ACCEPT_URL      => '_accept_url',
    ACCEPT_HTML     => '_accept_html',
    SEND_MAIL_TEXT  => '_mail_text',
    SEND_MAIL_HTML  => '_mail_html',
    REPLY_MAIL_TEXT => '_reply_text',
    REPLY_MAIL_HTML => '_reply_html',
    REPLY_ITEM      => '_reply_item',
    INIT_FORM       => '_init_form',
);
%RESERVE_CMD2 = (
    MAIL_FROM  => '_from',
    MAIL_TO    => '_to',
    MAIL_CC    => '_cc',
    MAIL_BCC   => '_bcc',
    MAIL_REPLY => '_reply',
    MAIL_ERROR => '_error',
    SUBJECT    => '_subject',
);
%ITEM_PROPERTY = (
    'A' => '[\s0-9A-Za-z]',
    'C' => '[\t\r\n\x20-\x7e]',
    'N' => '[0-9.-]',
    'P' => '[0-9-]',
    'H' => '\s|\xa1\xa1|\xa1\xbc|\xa1\xbd|\xa4[\xa1-\xf3]',   # euc
    'K' => '\s|\xa1\xa1|\xa1\xbc|\xa1\xbd|\xa5[\xa1-\xf6]',   # euc
);
%AUTO_FUNC = (
    format  => 'cmd_format',
    date    => 'cmd_date',
    time    => 'cmd_time',
    days    => 'cmd_days',
    wday    => 'cmd_wday',
    edit    => 'cmd_edit',
    config  => 'cmd_config',
    env     => 'cmd_env',
    sys     => 'cmd_sys',
    error   => 'error',
    abs     => 'abs',
    int     => 'int',
    sqrt    => 'sqrt',
    substr  => 'substr',
    length  => 'length',
    if      => 'if',
    unless  => 'unless',
    defined => 'defined',
);
$AUTO_CORE = 'and|or|not|xor|undef|last|if|unless|defined|length|substr|abs|int|sqrt';

my $temp_file_index = 'abcde';
my $mod_perl_support = undef;
my($jd_epoch, $jd_remainder);

my $CRLF = "\015\012";
my $end_of_parm = 0;
my $end_of_file = 0;
my $end_of_data = 0;

if($ENV{'MOD_PERL'} =~ m!^mod_perl/(\d+)!){
    $mod_perl_support = $1 || 1;
    if($mod_perl_support == 1){
        require Apache;
    }
}

MAIN: {
    init_value();
    parse_form() || error('01');
    get_config() || error('02');
    set_contrl();
    if($CONF{SUSPEND_FORM}){
        error('90');
    }
    load_plugs();
    if($CONF{INIT_FORM}){
        if($CONF{INIT_FORM_HTML} eq ""){
            error('01');
        }
        draw_form($CONF{INIT_FORM_HTML});
        last MAIN;
    }
    check_data();
    check_msgs();
    check_auto();
    if($CONF{CONTINUE}){
        draw_form($CONF{CONTINUE});
        last MAIN;
    }
    my($file, $ctrl) = set_log_file(); check_logs($file, $ctrl);
    if($CONF{CONFIRM}){
        file_lock($file) || error('10');
        write_conf('C', $CONF{CONFCTRL} = $ctrl, $file) || error('99');
        file_unlock();
        draw_form($CONF{CONFIRM_HTML});
        last MAIN;
    }
    if($CONF{SEND_TEST} eq '1' || $CONF{REPLY_TEST} eq '1'){
        draw_debug_page();
        last MAIN;
    }
    my $v = $CONF{DELETE_CRLF} || undef;
    my $n = 0;
    foreach (@INPUT_ORDER){
        next unless $FORM{$_};
        $FORM{$_} =~ s/$SEPCHAR/,/go;
        $FORM{$_} =~ s/\n//go if $v;
        $n += length($FORM{$_});
    }
    if($n == 0){
        error('22');
    }
    foreach (keys %AUTO_VALUES){
        next unless $FORM{$_};
        $FORM{$_} =~ s/$SEPCHAR/,/go;
        $FORM{$_} =~ s/\n//go if $v;
    }
    auto_fold_values();
    file_lock($file) || error('10');
    if($CONF{RCP_PREFIX} ne "" && $CONF{RCP_SAVE_FILE} ne ""){
        $SYS{RECEIPT} = set_receipt();
    }
    if($CONF{REPLY_ITEM} && $FORM{ $CONF{REPLY_ITEM} }){
        sendmail('reply') unless $CONF{NOT_REPLY_MAIL};
    }
    sendmail('mailto');
    write_conf('E', $CONF{CONFCTRL} || $ctrl, $file);
    file_unlock();
    if($FORM{'_attach_temp'} ne ""){
        foreach (split(/,/, $FORM{'_attach_temp'})){
            unlink "$ATTACH_DIR/$_";
        }
    }
    draw_accept();
}
exit_proc();


sub check_upload {
    my($name, $file, $size) = @_;
    return undef if $size > $MAX_FILE_SIZE;
#**********************************************************
#   ˥åץɥեΥåɲòǽǤ
#   undef֤ͤȥ顼ǽǡͤʤ³ԡ
#
#       $name: NAME°̾
#       $file: ե̾
#       $size: ե륵
#
#**********************************************************
    1;
}

sub init_value {
    %FORM = (); @INPUT_ORDER = (); %AUTO_VALUES = ();
    %CONF = (
        HTML_CODE => $PROGCODE,
        ITEM_NAME => (),
        ITEM_PGID => (),
        ITEM_REQR => [],
        ITEM_TYPE => {
            'A' => [], 'C' => [], 'H' => [], 'K' => [], 'M' => [], 'N' => [], 'P' => [],
        },
    );
    $CHARSET = $CHARSET{$PROGCODE};
    my @t = split(/ +/, time2date('%Y %M %D %h %m %s %W %n'));
    %SYS = (
        DATE  => join('/', $t[0], $t[1], $t[2]),
        TIME  => join(':', $t[3], $t[4], $t[5]),
        YEAR  => $t[0],
        MONTH => $t[1],
        DAY   => $t[2],
        HOUR  => $t[3],
        MIN   => $t[4],
        SEC   => $t[5],
        WDAY  => $t[6],
        YDAY  => $t[7],
        RAND  => sprintf("%05d", 10000 + int(rand(32767))),

        OSNAME => $^O, PID => $$, UID => $<, EUID => $>, GID => $(, EGID => $),
        TIMEZONE => $TIMEZONE,
        PROGCODE => $PROGCODE,
        CHARSET  => $CHARSET,
        VERSION  => $VERSION,
    );
    $ERROR_ITEMS = $ERROR_MESSAGE = undef;
    $USER_AGENT  = $ENV{HTTP_USER_AGENT};
    $REMOTE_ADDR = $ENV{REMOTE_ADDR};
    $REMOTE_HOST = $ENV{REMOTE_HOST};
    $SIG{INT} = $SIG{QUIT} = $SIG{TERM} = $SIG{__DIE__} = \&exit_proc;
}

sub parse_form {
    my $method = $ENV{REQUEST_METHOD};
    my $ctype  = $ENV{CONTENT_TYPE};
    my $length = $ENV{CONTENT_LENGTH};
    if($method eq 'GET' || $ctype =~ m!^application/x-www-form-urlencoded!oi){
        urlencode_parse($method, $ctype, $length) || return undef;
    } elsif($ctype =~ m!^multipart/form-data!oi){
        multipart_parse($method, $ctype, $length) || return undef;
    } else {
        return undef;
    }
    my($icode, $k, $v);
    while (($k, $v) = each %FORM){
        if($v =~ /[\e\x80-\xff]/o){
            $icode = jcode::convert(\$v, $PROGCODE, $icode, 'z');
            $icode = undef unless defined $CHARSET{$icode};
        }
        $v =~ s/\$(FORM|IF|SELECT|ENV|SYS)?\{(.+?)\}/\$$1 {$2}/go;
        $FORM{$k} = $v;
    }
    1;
}

sub urlencode_parse {
    my($method, $ctype, $length) = @_;
    my $buff = "";
    if($method eq 'POST'){
        if($length > $MAX_POST){
            return undef;
        }
        read(STDIN, $buff, $length);
        _parse_param(\$buff) if length($buff);
    }
    $buff = $mod_perl_support == 1 ? Apache->request->args() : $ENV{QUERY_STRING};
    if($buff =~ s/^([^&=]+)(?:&|$)//o){
        $CONF{INIT_FORM} = $1;
    }
    _parse_param(\$buff) if length($buff);
    1;
}

sub _parse_param {
    my($k, $v);
    foreach (split(/&/, ${$_[0]})){
        ($k, $v) = split(/=/);
        $k  =~ tr/+/ /;
        $k  =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
        $k =~ s/[\t\r\n]//go;
        $v =~ tr/+/ /;
        $v =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
        $v =~ s/\t//go;
        $v =  decode_ctrl($v);
        $v =  meta_decode($v);
        $v =~ s/\r\n/\n/go;
        $v =~ tr/\r/\n/;
        $v =~ s/[\n\s]+$//o;
        if($FORM{$k} ne ""){
            $FORM{$k} .= $SEPCHAR;
        } else {
            push(@INPUT_ORDER, $k);
        }
        $FORM{$k} .= $v;
    }
    1;
}

sub multipart_parse {
    my($method, $ctype, $length) = @_;
    if($method ne 'POST' || $length > $MAX_POST){
        return undef;
    }
    if($length == 0){
        return 1;
    }
    my($boundary) = $ctype =~ /boundary="?([^ ";]+)/oi;
    if($boundary eq ""){
        return undef;
    }
    $boundary = join('', $CRLF, '--', $boundary);
    my $maxlen = $MAX_READ_SIZE + length($boundary) + 4;
    my($error, $buff, $file, $size, $name, $value, $mlen, $fh, $temp, @files);
    ($end_of_parm, $end_of_file, $end_of_data) = (0, 0, 0);
    binmode(STDIN);
    while (!$end_of_parm){
        ($length, $value, $buff) = read_header($length, $maxlen, $buff);
        last if $end_of_parm;
        $ctype = $file = $name = undef;
        foreach (split(/$CRLF/, $value)){
            if(/^Content-Disposition:/oi){
                ($name) = /\bname="?([^";]+)/oi;
                ($file) = /\bfilename="?([^";]+)/oi;
                ($file) = $file =~ m!([^:/\\]+)$!o;
            } elsif(/^Content-Type: *([^\s:;]+)/oi){
                $ctype = $1;
            }
        }
        $name =~ s/["']//go; $name =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
        $file =~ s/["']//go; $file =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
        if($file ne ""){
            unless($ENABLE_UPLOAD){
                $error = 1; last;
            }
            ($fh, $temp) = open_temp($file);
            unless($fh){
                $error = 1; last;
            }
            push(@files, $temp);
            $end_of_data = $size = 0;
            $mlen = $length + length($buff);
            if($ctype =~ m!application/x-macbinary!oi){
                ($length, $value, $buff) = read_attach($boundary, $length, $maxlen, $buff);
                if(length($value) > 128){
                    $mlen = unpack("N", substr($value, 83, 4));
                    if($mlen <= length($value) - 128){
                        $value = substr($value, 128, $mlen);
                    } else {
                        $value = substr($value, 128);
                    }
                    print $fh $value;
                    $size += length($value);
                    $mlen -= length($value);
                }
            }
            while (!$end_of_parm && !$end_of_data){
                ($length, $value, $buff) = read_attach($boundary, $length, $maxlen, $buff);
                if($mlen > 0){
                    if($mlen <= length($value)){
                        $value = substr($value, 0, $mlen);
                    }
                    print $fh $value;
                    $size += length($value);
                    $mlen -= length($value);
                }
            }
            close $fh;
            unless(check_upload($name, $file, $size)){
                $error = 1; last;
            }
            $FORM{$name} = $file;
            $FORM{"$name\_size"} = $size;
            if($FORM{'_attach_file'} ne ""){
                $FORM{'_attach_file'} .= ',';
                $FORM{'_attach_temp'} .= ',';
                $FORM{'_attach_size'} .= ',';
            }
            $FORM{'_attach_file'} .= $file;
            $FORM{'_attach_temp'} .= $temp;
            $FORM{'_attach_size'} .= $size;
            push(@INPUT_ORDER, $name, "$name\_size");
        } else {
            ($length, $value, $buff) = read_value($boundary, $length, $maxlen, $buff);
            $value =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
            $value =~ s/\t//go;
            $value =  decode_ctrl($value);
            $value =  meta_decode($value);
            $value =~ s/\r\n/\n/go;
            $value =~ tr/\r/\n/;
            $value =~ s/[\n\s]+$//o;
            if($FORM{$name} ne ""){
                $FORM{$name} .= $SEPCHAR;
            } else {
                push(@INPUT_ORDER, $name);
            }
            $FORM{$name} .= $value;
        }
    }
    if($error){
        foreach (@files){ unlink "$ATTACH_DIR/$_"; }
        if(!$end_of_file){
            while (1){
                read(STDIN, $value, $maxlen, 0) or last;
            }
        }
        return undef;
    }
    delete_temp() if @files;
    1;
}

sub read_header {
    my($length, $maxlen, $line) = @_;
    my($buff, $bytes, $i);
    while (1){
        if(($i = index($line, "$CRLF$CRLF")) >= 0){
            return ($length, substr($line, 0, $i), substr($line, $i + 4));
        }
        last if $end_of_file;
        $i = $length > $maxlen ? $maxlen : $length;
        $bytes = read(STDIN, $buff = "", $i, 0);
        if(!$bytes){
            last;
        }
        $line .= $buff; $length -= $bytes;
    }
    $end_of_parm = $end_of_file = 1;
    return undef;
}

sub read_value {
    my($boundary, $length, $maxlen, $line) = @_;
    my($buff, $bytes, $i, $j);
    while (1){
        if(($i = index($line, $boundary)) >= 0){
            $j = $i + length($boundary);
            if(substr($line, $j, 2) eq '--'){
                $end_of_parm = 1;
                return ($length, substr($line, 0, $i), "");
            }
            return ($length, substr($line, 0, $i), substr($line, $j + 2));
        }
        last if $end_of_file;
        $i = $length > $maxlen ? $maxlen : $length;
        $bytes = read(STDIN, $buff = "", $i, 0);
        if(!$bytes){
            last;
        }
        $line .= $buff; $length -= $bytes;
    }
    $end_of_parm = $end_of_file = 1;
    return undef;
}

sub read_attach {
    my($boundary, $length, $maxlen, $line) = @_;
    my($buff, $bytes, $i, $j);
    if(!$end_of_file){
        $i = $length > $maxlen ? $maxlen : $length;
        $bytes = read(STDIN, $buff = "", $i, 0);
        if(!$bytes){
            $end_of_file = 1;
        } else {
            $line .= $buff; $length -= $bytes;
        }
    }
    if(($i = index($line, $boundary)) >= 0){
        $j = $i + length($boundary);
        $end_of_data = 1;
        if(substr($line, $j, 2) eq '--'){
            $end_of_parm = 1;
            return ($length, substr($line, 0, $i), "");
        }
        return ($length, substr($line, 0, $i), substr($line, $j + 2));
    } else {
        $end_of_parm = $end_of_file;
    }
    if(($i = length($line) - length($boundary)) > 0){
        return ($length, substr($line, 0, $i), substr($line, $i));
    }
    return ($length, $line, "");
}

sub open_temp {
    my $file = shift;
    my($suffix, $temp);
    if($file =~ /\.([^.]+)$/o){
        $suffix = $1;
    } else {
        $suffix = 'dat';
    }
    my $loop = 10;
   TEMP_LOOP: {
        $temp = join('.', time(), $$, $temp_file_index++, $suffix);
        if(-e "$ATTACH_DIR/$temp"){
            --$loop > 0 ? redo TEMP_LOOP : return undef;
        }
    }
    my $fh = Symbol::gensym();
    open($fh, "> $ATTACH_DIR/$temp") or return undef;
    binmode($fh);
    return ($fh, $temp);
}

sub delete_temp {
    my $dh = Symbol::gensym();
    opendir($dh, $ATTACH_DIR);
    my @files = readdir($dh);
    closedir($dh);
    no integer;
    foreach (@files){
        next if($_ eq '.' || $_ eq '..');
        unlink "$ATTACH_DIR/$_" if((-M "$ATTACH_DIR/$_") > 0.0416);
    }
    use integer;
}

sub get_config {
    $FORM_NAME = delete $FORM{_form_name} || $CONF{INIT_FORM};
    $FORM_URL  = delete $FORM{_form_url}  || $ENV{HTTP_REFERER};
    $FORM_NAME =~ s/[^.0-9A-Za-z_-]//go;
    my $file = $FORM_NAME ? trans2path(join('.', $FORM_NAME, $CONF_SUFFIX)) : join('/', $CONF_DIR, $CONF_FILE);
    my $fh = Symbol::gensym();
    my($icode, $g, $k, $v, $t, $d, $q);
    open($fh, "< $file") or return undef;
    while (<$fh>){
        tr/\t/ /;
        next if /^\s*#/o;
        next if /^\s*$/o;
        s/^\s+//o; s/[\r\n\s]+$//o;
        if(m!^<([/])?([^>]+)>!o){
            if($1 eq '/'){
                $g = undef;
            } else {
                $g = uc($2);
                $CONF{$g} = [] if $g ne 'DEFINE_ITEM';
            }
        } else {
            unless($icode){
                $icode = jcode::getcode(\$_) if /[\e\x80-\xff]/o;
            }
            unless($g){
                if(($k, $v) = /^(.+?)\s*=\s*(.*?)$/o){
                    $CONF{$k} = ($v =~ /^["'](.*?)["']$/o) ? $1 : $v;
                }
                next;
            }
            if($g eq 'DEFINE_ITEM'){
                ($k, $v, $t, $d, $q) = split(/\s*,\s*/);
                $CONF{ITEM_NAME}{$k} = $v;
                if($t =~ /^[ACHKMNP]$/o){
                    push(@{ $CONF{ITEM_TYPE}{$t} }, $k);
                }
                if($d ne "" && $d ne '*'){
                    $CONF{ITEM_PGID}{$k} = $d;
                }
                if($q eq 'require'){
                    push(@{ $CONF{ITEM_REQR} }, $k);
                }
            } else {
                push(@{ $CONF{$g} }, $_);
            }
        }
    }
    close $fh;
    if($icode ne $PROGCODE && exists $CHARSET{$icode}){
        if(defined $CONF{DEFINE_ITEM}){
            foreach (@{ $CONF{DEFINE_ITEM} }){
                jcode::convert(\$_, $PROGCODE, $icode);
            }
        }
        if(defined $CONF{REFERENCE_ITEM}){
            foreach (@{ $CONF{REFERENCE_ITEM} }){
                jcode::convert(\$_, $PROGCODE, $icode);
            }
        }
        if(defined $CONF{AUTO_VALUES}){
            foreach (@{ $CONF{AUTO_VALUES} }){
                jcode::convert(\$_, $PROGCODE, $icode);
            }
        }
        if(defined $CONF{DEFINE_MESSAGE}){
            foreach (@{ $CONF{DEFINE_MESSAGE} }){
                jcode::convert(\$_, $PROGCODE, $icode);
            }
        }
    }
    return delete($CONF{END_OF_CONFIG});
}

sub set_contrl {
    my($k, $v);
    while (($k, $v) = each %RESERVE_CMD1){
        if(exists $FORM{$v}){
            $CONF{$k} = delete $FORM{$v};
            $CONF{$k} =~ s!^[%./:~\\]+!!go;
        } elsif(defined $CONF{$k}){
            $CONF{$k} =~ s!^[%./:~\\]+!!go;
        }
    }
    if($v = delete $FORM{_confirm}){
        $v =~ s!^[%./:~\\]+!!go;
        if($v =~ /\D/o){
            $CONF{CONFIRM_HTML} = $v;
        }
        $CONF{CONFIRM} = 1;
    }
    if($CONF{ENABLE_OVERRIDE}){
        while (($k, $v) = each %RESERVE_CMD2){
            $CONF{$k} = $FORM{$v} if exists $FORM{$v};
        }
    }
    $CHARSET = $CHARSET{ $CONF{HTML_CODE} };
    if($IMAGE_URL = delete $FORM{_image_url}){
        $CONF{IMAGE_URL} = $IMAGE_URL;
    } else {
        $IMAGE_URL = delete $CONF{IMAGE_URL};
    }
    if(defined $CONF{SEND_TEST} || defined $CONF{REPLY_TEST}){
        if($ENABLE_SIMULATE){
            if($CONF{SEND_TEST} ne '1' && $CONF{SEND_TEST} ne '0'){
                delete $CONF{SEND_TEST};
                delete $CONF{REPLY_TEST};
            }
        } else {
            delete $CONF{SEND_TEST};
            delete $CONF{REPLY_TEST};
        }
    }
}

sub draw_form {
    my $file = shift;
    foreach (@INPUT_ORDER){
        next unless exists $FORM{$_};
        $FORM{$_} = meta_encode($FORM{$_});
    }
    draw_page(trans2path($file));
}

sub draw_accept {
    if($CONF{ACCEPT_URL}){
        http_header($CONF{ACCEPT_URL});
    } else {
        my $file = $CONF{ACCEPT_HTML} ? trans2path($CONF{ACCEPT_HTML}) : join('/', $CONF_DIR, 'accept.html');
        draw_page($file);
    }
}

sub check_data {
    if($CONF{CHECK_REFERER} > 0){
        check_referer($FORM_URL, $HOME_URL) || error('04');
    }
    my $proxy = check_proxy();
    unless(check_allow()){
        if($CONF{DENY_PROXY} && $proxy){
            error('05');
        }
    }
    if($CONF{CONTINUE} && $CONF{CHECK_ID} eq ""){
        return;
    }
    check_condition();
    check_mail_addr() unless $CONF{CONTINUE};
}

sub check_condition {
    my(@a, $k, $v, $n, $m, $c, $i, $j, $t, $error, @items);
    my $id = $CONF{CONTINUE} ? $CONF{CHECK_ID} : undef;
    foreach $k (@{ $CONF{ITEM_REQR} }){
        next if($id ne "" && $id ne $CONF{ITEM_PGID}{$k});
        $v = $FORM{$k};
        $v =~ s/[\n\s]//go;
        $v =~ s///go;
        if(length($v) == 0){
            $error = '11'; push(@items, $k);
        }
    }
    error($error, @items) if $error;
    if(defined $CONF{REFERENCE_ITEM}){
        foreach (@{ $CONF{REFERENCE_ITEM} }){
            if(/^([^ ]+) +([^ ]+) +(.+?) *, *(ALL|ANY|ONLY) *, *(.+?)$/o){
                next if($id ne "" && $id ne $CONF{ITEM_PGID}{$1});
                if(exists $OPERATORS{$2}){
                    if(eval "\$FORM{\$1} $2 $3"){
                        $m = $4; $c = $5; $i = $j = $n = 0; @a = ();
                        foreach $k (split(/\s*,\s*/, $c)){
                            $j++; $t = 0;
                            foreach $v (split(/$SEPCHAR/, $FORM{$k})){
                                $v =~ s/\n//go;
                                $v =~ s/\s//go;
                                $v =~ s///go;
                                if(length($v) > 0){ $i++; $t = 1; }
                            }
                            $n += $t;
                            push(@a, $k);
                        }
                        if($m eq 'ANY'  && $i == 0){ $error = '19'; push(@items, @a); }
                        if($m eq 'ALL'  && $j > $n){ $error = '20'; push(@items, @a); }
                        if($m eq 'ONLY' && $i != 1){ $error = '21'; push(@items, @a); }
                    }
                }
            }
            last if $error;
        }
    }
    error($error, @items) if $error;
    foreach $t ('A', 'C'){
        $c = $ITEM_PROPERTY{$t};
        foreach $k (@{ $CONF{ITEM_TYPE}{$t} }){
            next if($FORM{$k} eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$k}));
            foreach $v (split(/$SEPCHAR/, $FORM{$k})){
                if($v !~ /^(?:$c)+$/){
                    $error = '12'; push(@items, $k);
                }
            }
        }
    }
    error($error, @items) if $error;
    foreach $t ('N', 'P'){
        $c = $ITEM_PROPERTY{$t};
        foreach $k (@{ $CONF{ITEM_TYPE}{$t} }){
            next if($FORM{$k} eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$k}));
            foreach $v (split(/$SEPCHAR/, $FORM{$k})){
                if($v !~ /^(?:$c)+$/ || $v =~ /(?:\D\D|\D$)/o){
                    $error = '13'; push(@items, $k);
                }
            }
        }
    }
    error($error, @items) if $error;
    foreach $t ('H', 'K'){
        $c = $ITEM_PROPERTY{$t};
        foreach $k (@{ $CONF{ITEM_TYPE}{$t} }){
            next if(($v = $FORM{$k}) eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$k}));
            if($PROGCODE ne 'euc'){
                jcode::convert(\$v, 'euc', $PROGCODE);
            }
            if($v !~ /^(?:$c)+$/){
                $error = $t eq 'H' ? '14' : '26';
                push(@items, $k);
            }
        }
        last if $error;
    }
    error($error, @items) if $error;
    @a = ();
    foreach $k (@{ $CONF{ITEM_TYPE}{'M'} }){
        next if($FORM{$k} eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$k}));
        if(check_email($FORM{$k})){
            push(@a, $k, $FORM{$k});
        } else {
            $error = '15'; push(@items, $k);
        }
    }
    error($error, @items) if $error;
    if(@a > 0 && (@DENY_MAIL_ADDR > 0 || defined $CONF{DENY_MAIL_ADDR})){
        while (($k, $v) = splice(@a, 0, 2)){
            foreach $t (@DENY_MAIL_ADDR, @{ $CONF{DENY_MAIL_ADDR} }){
                $t =~ s/(\W)/\\$1/go;
                if($v =~ /$t$/){
                    $error = '25'; push(@items, $k);
                }
            }
        }
    }
    error($error, @items) if $error;
    if(defined $CONF{SELECT_ITEM}){
        foreach (@{ $CONF{SELECT_ITEM} }){
            if(/^(\d+)\s*:\s*(\d+)\s*,\s*(.+?)$/o){
                $m = $1; $n = $2; $c = $3; $i = 0; @a = ();
                foreach $v (split(/\s*,\s*/, $c)){
                    next if($id ne "" && $id ne $CONF{ITEM_PGID}{$v});
                    foreach $t (split(/$SEPCHAR/, $FORM{$v})){
                        $i++ if length($t);
                    }
                    push(@a, $v);
                }
                if($i < $m || $i > $n){
                    $error = '16'; push(@items, @a);
                }
            }
        }
    }
    error($error, @items) if $error;
    if(defined $CONF{CONFIRM_ITEM}){
        foreach (@{ $CONF{CONFIRM_ITEM} }){
            if(/^(.+?)\s*=\s*(.+?)$/o){
                next if($id ne "" && $id ne $CONF{ITEM_PGID}{$1});
                if($FORM{$1} ne "" && $FORM{$1} ne $FORM{$2}){
                    $error = '17'; push(@items, $1);
                }
            }
        }
    }
    error($error, @items) if $error;
    if(defined $CONF{NUMERIC_ITEM}){
        foreach (@{ $CONF{NUMERIC_ITEM} }){
            if(/^(.+?)\s*=\s*([0-9.-]+)\s*:\s*([0-9.-]+)$/o){
                next if(($v = $FORM{$1}) eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$1}));
                if($v < $2 || $v > $3){
                    $error = '18'; push(@items, $1);
                }
            }
        }
    }
    error($error, @items) if $error;
    if(defined $CONF{LENGTH_ITEM}){
        foreach (@{ $CONF{LENGTH_ITEM} }){
            if(/^(.+?)\s*=\s*([0-9.-]+)\s*:\s*([0-9.-]+)\s*([SCPN]*)$/o){
                next if(($v = $FORM{$1}) eq "" || ($id ne "" && $id ne $CONF{ITEM_PGID}{$1}));
                ($k, $n, $m, $t) = ($1, $2, $3, $4);
                if($t eq 'S'){
                    $v =~ s/\s//go;
                } elsif($t eq 'C'){
                    $v =~ s/\,//go;
                } elsif($t eq 'P'){
                    $v =~ s/\-//go;
                } elsif($t eq 'N'){
                    $v =~ s/\n//go;
                }
                if(length($v) < $n || length($v) > $m){
                    $error = '24'; push(@items, $k);
                }
            }
        }
    }
    error($error, @items) if $error;
}

sub check_msgs {
    return undef unless defined $CONF{DEFINE_MESSAGE};
    my($k, $v);
    foreach (@{ $CONF{DEFINE_MESSAGE} }){
        if(/^(\S+)\s*=\s*["']?(.+?)["']?$/o){
            $FORM{$1} = $2;
        }
    }
}

sub load_plugs {
    if(defined $CONF{LOAD_MODULES}){
        local $@;
        my $stat;
        foreach (@{ $CONF{LOAD_MODULES} }){
            if(-e "$PLUG_DIR/$_"){
                $stat = eval("do '$PLUG_DIR/$_';");
                if($@ || !$stat){
                    $FORM{'_E_'} = qq(can't compile Plug-in module: "$_");
                    error('70');
                }
            } else {
                $FORM{'_E_'} = qq(Plug-in module not found: "$_");
                error('70');
            }
        }
    }
}

sub check_auto {
    return undef unless defined $CONF{AUTO_VALUES};
    my @buff = ();
    my $line = 1;
    foreach (@{ $CONF{AUTO_VALUES} }){
        s/\s*;$//o; s/[`].+?[`]//go;
        if(/^([\s}]*(?:if|elsif|unless))\s*\(\s*(.+?)\s*\)\s*([{])?$/o){
            push(@buff, $1, '(', parse_expr($line,'','', $2), ")$3\n");
        } elsif(/^(?:[\s{}]+|[\s}]*else\s*[{]?)$/o){
            push(@buff, "$_\n");
        } elsif(m!^(.+?)\s*([\x21\x25\x26\x2a\x2b\x2d-\x2f\x3c\x3e\x5e]*[=?])\s*(.+)$!o){
            push(@buff, parse_expr($line, $1, $2, $3), ";\n");
        } elsif(/^([Ee][Rr][Rr][Oo][Rr]\(\s*.+\s*\)|last)$/o){
            push(@buff, parse_expr($line,'','', $1), ";\n");
        } elsif($_ ne ''){
            $FORM{'_E_'} = qq(syntax error at line $line, "$_");
            error('23');
        }
        $line++;
    }
    return undef if @buff == 0;
    local $@;
    my $eval = join('', @buff);
    no integer;
    eval $eval;
    if($@){
        ($FORM{'_E_'} = $@) =~ s/[\s(]*eval\s*\d+[\s)]*//o;
        error('23');
    }
    use integer;
}

sub parse_expr {
    my($line, $n, $t, $e) = @_;
    my @exp = ();
    if($n ne ""){
        $n =~ s/(["'])([^\1]+?)\1/$1.encode_literal($2).$1/ego;
        $n =~ s/([,()])/ $1 /go;
        foreach (split(/\s+/, $n)){
            next if $_ eq '';
            if(/^[,()]$/o){
                push(@exp, $_);
            } else {
                push(@exp, "\$FORM{'$_'}");
                $AUTO_VALUES{$_} = 1;
            }
        }
        push(@exp, $t);
    }
    $e =~ s/(["'])([^\1]+?)\1/$1.encode_literal($2).$1/ego;
    $e =~ s/([,()]+)/ $1 /go;
    $e =~ s/((?:[A-Za-z_]\w*::)?[A-Za-z_][\w:]*)\s*\(/&$1(/go;
    foreach (split(/\s+/, $e)){
        next if $_ eq '';
        $t = s/\s*;$//o ? ';' : '';
        if(/^(?:["'].*?["']|[+-]?[0-9.]+|[\x21\x25\x26\x28-\x2f\x3a-\x3f\x5e\x78\x7c]+|$AUTO_CORE)$/o || defined $OPERATORS{$_}){
            push(@exp, "$_$t");
        } elsif(/^&([A-Za-z_]\w*)::([a-zA-Z_][\w:]*)\($/o){
            if(defined &{"$1::$2"}){
                push(@exp, "$1::$2(\\%FORM,");
            } else {
                $FORM{'_E_'} = qq(undefined plug-in at line $line, "$1::$2");
                error('70');
            }
        } elsif(/^&([A-Za-z_]\w*)\($/o){
            if(defined $AUTO_FUNC{lc($1)}){
                push(@exp, "$AUTO_FUNC{lc($1)}(");
            } elsif($1 eq 'and' || $1 eq 'or' || $1 eq 'not' || $1 eq 'xor'){
                push(@exp, "$1 (");
            } else {
                $FORM{'_E_'} = qq(invalid function at line $line, "$1");
                error('27');
            }
        } elsif(/^[A-Za-z_]/o){
            push(@exp, "\$FORM{'$_'}$t");
        } else {
            push(@exp, "'$_'$t");
        }
    }
    $e = decode_literal(join(' ', @exp));
}

sub encode_literal {
    my $s = shift;
    $s =~ tr/\x20\x22\x27\x28\x29\x2c\x3b\x3d/\x11\x12\x13\x14\x15\x16\x17\x18/;
    $s;
}

sub decode_literal {
    my $s = shift;
    $s =~ tr/\x11\x12\x13\x14\x15\x16\x17\x18/\x20\x22\x27\x28\x29\x2c\x3b\x3d/;
    $s;
}

sub cmd_date {
    my $pat = shift;
    my(@date, $v);
    my($dy, $dm, $dd) = (0, 0, 0);
    my $i = 0;
    foreach (@_){
        if(/^([+-])?([0-9]+)(Y|M|D)$/o){
            $v = $1 eq '-' ? $2 * -1 : $2;
            if($3 eq 'Y'){ $dy = $v; next; }
            if($3 eq 'M'){ $dm = $v; next; }
            if($3 eq 'D'){ $dd = $v; next; }
        } else {
            $date[$i++] = $_;
        }
    }
    $date[0] = $SYS{YEAR}  if $date[0] eq "";
    $date[1] = $SYS{MONTH} if $date[1] eq "";
    $date[2] = $SYS{DAY}   if $date[2] eq "";
    if($pat eq '?'){
        if($date[0] < 1900 || $date[1] < 1 || $date[1] > 12 || $date[2] < 1 || $date[2] > end_of_month(@date[0, 1])){
            return undef;
        } else {
            return 1;
        }
    }
    @date = days_date(@date[0, 1, 2], $dy, $dm, $dd);
    return $pat ? time2edit($pat, @date) : @date;
}

sub cmd_time {
    my $pat = shift;
    my(@time, $v);
    my($dh, $dm, $ds) = (0, 0, 0);
    my $i = 0;
    foreach (@_){
        if(/^([+-])?([0-9]+)(H|M|S)$/o){
            $v = $1 eq '-' ? $2 * -1 : $2;
            if($3 eq 'H'){ $dh = $v; next; }
            if($3 eq 'M'){ $dm = $v; next; }
            if($3 eq 'S'){ $ds = $v; next; }
        } else {
            $time[$i++] = $_;
        }
    }
    $time[0] = $SYS{HOUR}  if $time[0] eq "";
    $time[1] = $SYS{MIN}   if $time[1] eq "";
    $time[2] = $SYS{SEC}   if $time[2] eq "";
    $time[3] = $SYS{YEAR}  if $time[3] eq "";
    $time[4] = $SYS{MONTH} if $time[4] eq "";
    $time[5] = $SYS{DAY}   if $time[5] eq "";
    if($pat eq '?'){
        if($time[0] < 0 || $time[0] > 23 || $time[1] < 0 || $time[1] > 59 || $time[2] < 0 || $time[2] > 59 ||
           $time[3] < 1900 || $time[4] < 1 || $time[4] > 12 || $time[5] < 1 || $time[5] > end_of_month(@time[3, 4])){
            return undef;
        } else {
            return 1;
        }
    }
    @time = days_time(@time[0, 1, 2, 3, 4, 5], $dh, $dm, $ds);
    return $pat ? time2edit($pat, @time) : @time;
}

sub cmd_days {
    my($y0, $m0, $d0, $y1, $m1, $d1) = @_;
    if($y1 eq "" || $m1 eq "" || $d1 eq ""){
        ($y1, $m1, $d1) = ($SYS{YEAR}, $SYS{MONTH}, $SYS{DAY});
    }
    return (gd2jd($y0, $m0, $d0) - gd2jd($y1, $m1, $d1));
}

sub cmd_wday {
    my($y, $m, $d) = @_;
    $y = $SYS{YEAR}  if $y eq "";
    $m = $SYS{MONTH} if $m eq "";
    $d = $SYS{DAY}   if $d eq "";
    return date2wday($y, $m, $d);
}

sub cmd_edit {
    my $type = shift;
    if($type eq 'CD'){
        return comma_digit(@_);
    }
    return undef;
}

sub cmd_format {
    my $pat = shift;
    if(@_){
        return sprintf($pat, @_);
    }
    return undef;
}

sub cmd_config {
    my $k = shift;
    if(defined $CONF{$k}){
        return ref $CONF{$k} ? undef : $CONF{$k};
    }
    return undef;
}

sub cmd_env { $ENV{$_[0]}; }
sub cmd_sys { $SYS{$_[0]}; }

sub comma_digit {
    my $d = shift;
    my $e = $d =~ s/^[-]//o ? '-' : '';
    my $x = $d =~ s/(\.\d+)$//o ? $1 : '';
    $d =~ s/^\D+//o; $d += 0;
    my $n = length($d);
    if($n <= 3){
        return join('', $e, $d, $x);
    }
    $n = 3 - ($n % 3);
    $n = 0 if $n == 3;
    foreach (split(//, $d)){
        if(++$n > 3){
            $e .= ','. $_;
            $n = 1;
        } else {
            $e .= $_;
        }
    }
    return join('', $e, $x);
}

sub days_date {
    my($y, $m, $d, $dy, $dm, $dd) = @_;
    $y += $dy;
    $m += $dm;
    $y += int($m / 12);
    if($m < 1){
        $y -= 1;
        $m = ($m + 12) % 12;
        if($m == 0){
            $m = 12;
        }
    } else {
        $m = $m % 12;
        if($m == 0){
            $m = 12;
            $y -= 1;
        }
    }
    if($d > ($dm = end_of_month($y, $m))){
        $d = $dm;
    }
    return $dd != 0 ? jd2gd(gd2jd($y, $m, $d) + $dd) : ($y, $m, $d);
}

sub days_time {
    my($h, $n, $s, $y, $m, $d, $dh, $dm, $ds) = @_;
    my $jd = gd2jd($y, $m, $d);
    my $ut = jd2ut($jd, $h, $n, $s);
    my @t = gmtime($ut + $dh * 3600 + $dm * 60 + $ds);
    $t[5] += 1900;
    $t[4] += 1;
    return (@t[5, 4, 3, 2, 1, 0, 6, 7]);
}

sub gd2jd {
    my($y, $m, $d) = @_;
    my $jd = $d - 32075
      + 1461 * ($y + 4800 - (14 - $m) / 12) / 4
      + 367 * ($m - 2 + ((14 - $m) / 12) * 12) / 12
      - 3 * (($y + 4900 - (14 - $m) / 12) / 100) / 4
    ;
    return $jd;
}

sub jd2gd {
    my $jd = shift;
    my($y, $m, $d, $t);
    $t = $jd - 1721119;
    $y = (4 * $t - 1) / 146097;
    $t = 4 * $t - 1 - 146097 * $y;
    $d = $t / 4;
    $t = (4 * $d + 3) / 1461;
    $d = 4 * $d + 3 - 1461 * $t;
    $d = ($d + 4) / 4;
    $m = (5 * $d - 3) / 153;
    $d = 5 * $d - 3 - 153 * $m;
    $d = ($d + 5) / 5;
    $y = 100 * $y + $t;
    if($m < 10){
        $m += 3;
    } else {
        $m -= 9;
        $y += 1;
    }
    return ($y, $m, $d);
}

sub jd2ut_init {
    my($s, $n, $h, $d, $m, $y) = gmtime(0);
    $y += 1900;
    if($y == 1970 && $m == 0 && $d == 1){
        $jd_epoch = 2440588;
    } else {
        $jd_epoch = gd2jd($y, $m + 1, $d);
    }
    $jd_remainder = $h * 3600 + $n * 60 + $s;
}

sub jd2ut {
    my($jd, $h, $m, $s) = @_;
    jd2ut_init() unless $jd_epoch;
    my $t = ($jd - $jd_epoch) * 86400 + $h * 3600 + $m * 60 - $jd_remainder;
    no integer;
    return ($t + $s);
    use integer;
}

sub day_of_week {
    return (($_[0] + 1) % 7);
}

sub end_of_month {
    my($y, $m) = @_;
    if($m == 2 && is_leap_year($y)){
        return 29;
    }
    (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[--$m];
}

sub is_leap_year {
    my $y = shift;
    return undef if(($y % 4) != 0);
    return undef if(($y % 100) == 0 && ($y % 400) != 0);
    1;
}

sub time2date {
    my($pat, $time) = @_;
    $time = time() unless defined $time;
    my @t = gmtime($time + $TIMEZONE);
    $t[5] += 1900;
    $t[4] += 1;
    if($pat){
        $pat = time2edit($pat, $t[5], $t[4], $t[3], $t[2], $t[1], $t[0], $t[6], $t[7]);
    }
    return $pat || (@t[5, 4, 3, 2, 1, 0, 6, 7]);
}

sub time2edit {
    my($pat, @t) = @_;
    my %time = (
        'Y' => sprintf("%04d", $t[0]),
        'M' => sprintf("%02d", $t[1]),
        'D' => sprintf("%02d", $t[2]),
        'E' => sprintf("%02d", end_of_month($t[0], $t[1])),
        'h' => sprintf("%02d", $t[3]),
        'm' => sprintf("%02d", $t[4]),
        's' => sprintf("%02d", $t[5]),
        'W' => defined $t[6] ? $WDAY_OF_WEEK[$t[6]] : date2wday($t[0], $t[1], $t[2]),
        'n' => $t[7] || 0,
    );
    $time{'y'} = substr($time{'Y'}, 2);
    $pat =~ s/%([DEMWYhmnsy])/$time{$1}/g;
    return $pat;
}

sub date2wday {
    my $w = day_of_week(gd2jd(@_));
    $WDAY_OF_WEEK[$w];
}

sub auto_fold_values {
    my $len = $CONF{AUTO_FOLD_LENG};
    my $opt = $CONF{AUTO_FOLD_CRLF};
    foreach (@{ $CONF{AUTO_FOLD_ITEM} }){
        foreach my $n (split(/ *, */)){
            next unless $FORM{$n};
            $FORM{$n} = part_string($FORM{$n}, $len, $PROGCODE, $opt);
        }
    }
}

sub part_string {
    my($str, $len, $icode, $opt) = @_; $len ||= 70;
    $str =~ s/[\r\n]//go unless $opt;
    if(length($str) <= $len){
        return $str;
    }
    if($icode ne 'euc'){
        jcode::convert(\$str, 'euc', $icode);
    }
    my($res, $m, $s);
    foreach $m (split(/(\n)/, $str)){
        while (1){
            if(length($m) <= $len){
                $res .= $m;
                last;
            }
            $s = substr($m, 0, $len);
            if($s =~ /\x8f$/o || $s =~ tr/\x8e\xa1-\xfe/\x8e\xa1-\xfe/ % 2){
                chop($s);
                $m = substr($m, $len - 1);
            } else {
                $m = substr($m, $len);
            }
            $res .= "$s\n";
        }
    }
    if($icode ne 'euc'){
        jcode::convert(\$res, $icode, 'euc');
    }
    return $res;
}

sub check_mail_addr {
    my($k, $v);
    my $n = 0;
    foreach $k (qw(MAIL_TO MAIL_CC MAIL_BCC)){
        next unless $CONF{$k};
        $CONF{$k} =~ s/$SEPCHAR/,/go;
        foreach $v (split(/ *[,;] */, $CONF{$k})){
            $n++ if check_email($v);
        }
    }
    if($n == 0 || $n > 100 || !check_email($CONF{MAIL_FROM})){
        error('06');
    }
    if($CONF{MAIL_REPLY}){
        check_email($CONF{MAIL_REPLY}) || error('06');
    }
    if($CONF{MAIL_ERROR}){
        check_email($CONF{MAIL_ERROR}) || error('06');
    }
    1;
}

sub check_email {
    get_mail_addr($_[0]) =~ /^[.\w-]+\@\w+[.\w-]*[\w]$/o;
}

sub get_mail_addr {
    my $s = shift;
    $s =~ s/\n//go;
    $s =~ s/\s*\"[^"]*\"\s*//go;
    $s =~ s/\s*\([^)]*\)\s*//go;
    if($s =~ /<\s*([^>]+)\s*>/o){
        $s = $1;
    }
    $s =~ s/^\s+//o;
    $s =~ s/\s+$//o;
    $s;
}

sub check_referer {
    my($referer, $url) = @_;
    return undef unless $referer;
    $referer =~ s/%([A-Fa-f0-9]{2})/pack("C", hex($1))/ego;
    $referer =~ s/\\//go;
    $url =~ s/(\W)/\\$1/go;
    return 1 if($referer =~ /$url/ig);
    return undef;
}

sub check_allow {
    my($result, $addr);
    if(defined $CONF{ALLOW_ADDR}){
        foreach $addr (@{ $CONF{ALLOW_ADDR} }){
            $addr =~ s/\./\\\./go;
            if($REMOTE_ADDR =~ /^$addr/){
                $result = 1; last;
            }
        }
    }
    $result;
}

sub check_proxy {
    my($proxy, @orgaddr);
    foreach my $header ($ENV{HTTP_VIA},
                        $ENV{HTTP_PROXY_CONNECTION},
                        $ENV{HTTP_X_FORWARDED_FOR},
                        $ENV{HTTP_FORWARDED},
                        $ENV{HTTP_CLIENT_IP},
                        $ENV{HTTP_X_LOCKING},
                        $ENV{HTTP_SP_HOST},
                        $ENV{HTTP_XROXY_CONNECTION},
                        $ENV{HTTP_XONNECTION},
                        $ENV{HTTP_CACHE_INFO}){
        next unless $header;
        foreach my $addr (split(/[\s,;]+/, $header)){
            if($addr =~ /^\d+\.\d+\.\d+\.\d+$/o){
                next if(grep($_ eq $addr, @orgaddr));
                push(@orgaddr, $addr);
            }
        }
        $proxy = 1;
    }
    if($REMOTE_HOST eq "" || $REMOTE_HOST eq $REMOTE_ADDR){
        if($DNS_LOOKUP){
            $REMOTE_HOST = gethostbyaddr(pack('C4', split(/\./, $REMOTE_ADDR)), 2);
        }
    }
    if($REMOTE_HOST =~ /\bproxy/oi){
        $proxy = 1;
    }
    if($proxy){
        push(@orgaddr, 'unsolved') unless @orgaddr;
        $REMOTE_ADDR .= join(' ', ' [proxy]', @orgaddr);
    }
    $USER_AGENT =~ s/compatible;\s*//go;
    $SYS{USER_AGENT}  = $USER_AGENT;
    $SYS{REMOTE_ADDR} = $REMOTE_ADDR;
    $SYS{REMOTE_HOST} = $REMOTE_HOST;
    $proxy;
}

sub trans2path {
    my $file = shift;
    my $home = $HOME_URL; $home =~ s/(\W)/\\$1/go;
    my($path);
    if($TMPL_PLACE == 1 && $FORM_URL){
        if($FORM_URL =~ m!$home!){
            $path = $';
        }
        $path =~ s!([^/]+?)$!!o;
    } else {
        $path = "/$FORM_NAME/";
    }
    return join('', $HOME_PATH, $path, $file);
}

sub edit_header {
    my $buff = shift;
    push(@{$buff}, 'Reply-To', $CONF{MAIL_REPLY})  if $CONF{MAIL_REPLY};
    push(@{$buff}, 'Errors-To', $CONF{MAIL_ERROR}) if $CONF{MAIL_ERROR};
    push(@{$buff}, 'X-REMOTE-HOST', $REMOTE_HOST)  if $REMOTE_HOST;
    push(@{$buff}, 'X-REMOTO-ADDR', $REMOTE_ADDR);
    push(@{$buff}, 'X-HTTP-USER-AGENT', $USER_AGENT);
    push(@{$buff}, 'X-Mailer', "Formdecode Plus $VERSION [ja]");
}

sub edit_bodies {
    my($type, $temp, $buff) = @_;
    my(%copy, $f, @v);
    if($type eq 'html'){
        %copy = %FORM;
        foreach (@INPUT_ORDER){
            $FORM{$_} = meta_encode($FORM{$_});
            $FORM{$_} =~ s!\n!<br>\n!go;
        }
    }
    if($temp){
        get_template(trans2path($temp), $buff);
        foreach (@{$buff}){
            if(/\<\!\-\-\s+\%PLUG_INSERT%\s+PLUG\s*=\s*&?([^:]+)::([\w:]+)\(\s*([^)]*)\s*\)\s+\-\-\>/o){
                if(defined &{"$1::$2"}){
                    $_ = &{"$1::$2"}(\%FORM, parse_plug_insert($3));
                }
                next;
            }
            s/\$(FORM|SYS|ENV)\{\s*(.+?)\s*\}/${$1}{$2}/ego;
            s/\$SELECT\{\s*(.+?)\s*\}/trans_SELECT($1)/ego;
            s/\$IF\{\s*(.+?)\s*\}/trans_IF($1)/ego;
            s/\$\{(.+?)\}/${$1}/ego;
        }
    } else {
        foreach (@INPUT_ORDER){
            next unless exists $FORM{$_};
            push(@{$buff}, "$_ = $FORM{$_}\n");
        }
    }
    %FORM = %copy if %copy;
}

sub parse_plug_insert {
    (my $s = shift) =~ s/(["'])([^\1]+?)\1/$1.encode_literal($2).$1/ego;
    my @v = ();
    foreach (split(/\s*,\s*/, $s)){
        if(/^["'](.*?)["']$/o){
            push(@v, decode_literal($1));
        } elsif(/^\$(FORM|SYS)\{\s*(.+?)\s*\}$/o){
            push(@v, ${$1}{$2});
        } else {
            push(@v, $_);
        }
    }
    return @v;
}

sub trans_SELECT {
    (my $s = shift) =~ s/(["'])([^\1]+?)\1/$1.encode_literal($2).$1/ego;
    my($k, @c) = split(/\s*,\s*/, $s);
    my $w = "";
    if(exists $FORM{$k} && @c > 0){
        foreach $s (split(/,/, $FORM{$k})){
            foreach (@c){
                if(/^\Q${s}\E\s*=\s*["']?(.*?)["']?$/){
                    $w .= $w ne '' ? ",$1" : $1;
                }
            }
        }
        $w = decode_literal($w);
        $w =~ s/\$([A-Za-z_]\w*)/$FORM{$1}/go;
    }
    $w;
}

sub trans_IF {
    (my $s = shift) =~ s/(["'])([^\1]+?)\1/$1.encode_literal($2).$1/ego;
    my @c = split(/[\s,]+/, $s);
    my $w = "";
    if(@c > 3){
        if(exists $FORM{$c[0]} && defined $OPERATORS{$c[1]}){
            $c[2] = $1 if $c[2] =~ /^["']?(.*?)["']$/o;
            $c[3] = $1 if $c[3] =~ /^["']?(.*?)["']$/o;
            $c[4] = $1 if $c[4] =~ /^["']?(.*?)["']$/o;
            if($c[2] eq '' || $c[2] =~ /[^0-9.-]/o){
                $c[1] = $OPERATORS{$c[1]};
                $c[2] = "'$c[2]'";
            }
            $s = join('', '$FORM{$c[0]} ', "$c[1] $c[2] ? '$c[3]' : '$c[4]';");
            $s = decode_literal($s);
            $w = eval($s);
            $w =~ s/\$([A-Za-z_]\w*)/$FORM{$1}/go;
        }
    }
    $w;
}

sub dump_all {
    my($type) = @_;
    print qq(<input type="hidden" name="_form_name" value="$FORM_NAME">\n);
    print qq(<input type="hidden" name="_form_url" value="$FORM_URL">\n);
    print qq(<input type="hidden" name="_image_url" value="$IMAGE_URL">\n)       if $CONF{IMAGE_URL};
    print qq(<input type="hidden" name="_send_test" value="$CONF{SEND_TEST}">\n) if $CONF{SEND_TEST};
    print qq(<input type="hidden" name="_confctrl" value="$CONF{CONFCTRL}">\n)   if $CONF{CONFCTRL};
    my $code = $CONF{HTML_CODE};
    my($name, $value);
    foreach $name (@INPUT_ORDER){
        next unless defined $FORM{$name};
        next if $name =~ /^_attach_(?:file|temp|size)/o;
        $value = encode_ctrl($FORM{$name});
        if($code ne $PROGCODE){
            jcode::convert(\$value, $code, $PROGCODE);
        }
        print qq(<input type="hidden" name="$name" value="$value">\n);
        $FORM{$name} =~ s/$SEPCHAR/,/go;
    }
    if($FORM{'_attach_file'}){
        $value = encode_ctrl($FORM{'_attach_file'});
        if($code ne $PROGCODE){
            jcode::convert(\$value, $code, $PROGCODE);
        }
        print qq(<input type="hidden" name="_attach_file" value="$value">\n);
        print qq(<input type="hidden" name="_attach_temp" value="$FORM{'_attach_temp'}">\n);
        print qq(<input type="hidden" name="_attach_size" value="$FORM{'_attach_size'}">\n);
    }
    if($type ne 'plain'){
        foreach $name (@INPUT_ORDER){
            $FORM{$name} =~ s!\n!<br>\n!go;
        }
    }
}

sub draw_page {
    my $file = shift;
    my @temp = (); get_template($file, \@temp);
    my $code = $CONF{HTML_CODE};
    http_header();
    foreach (@temp){
        if(/\<\!\-\-\s+\%PLUG_INSERT%\s+PLUG\s*=\s*&?([^:]+)::([\w:]+)\(\s*([^)]*)\s*\)\s+\-\-\>/o){
            if(defined &{"$1::$2"}){
                &{"$1::$2"}(\%FORM, parse_plug_insert($3));
            } else {
                print qq(<!-- Undefined Plug-in: "$1::$2" -->\n);
            }
            next;
        }
        if(s/\$FORM\{_alldump\}[\r\n]*//o){
            dump_all();
        }
        s/\$(FORM|SYS|ENV)\{\s*(.+?)\s*\}/${$1}{$2}/ego;
        s/\$SELECT\{\s*(.+?)\s*\}/trans_SELECT($1)/ego;
        s/\$IF\{\s*(.+?)\s*\}/trans_IF($1)/ego;
        s/\$\{(.+?)\}/${$1}/ego;
        if($code ne $PROGCODE){
            jcode::convert(\$_, $code, $PROGCODE);
        }
        print $_;
    }
}

sub get_template {
    my($file, $temp) = @_;
    my $fh = Symbol::gensym();
    if(open($fh, "< $file")){
        @{$temp} = <$fh>;
        close $fh;
        if($PROGCODE ne $CONF{HTML_CODE}){
            foreach (@{$temp}){
                jcode::convert(\$_, $PROGCODE);
            }
        }
    } else {
        if($file ne "$CONF_DIR/error.html"){
            delete $CONF{ERROR_TMPL};
            error('03');
        }
    }
}

sub http_header {
    my($url) = @_;
    my $head = "";
    if($url){
        $head .= "Location: $url". $CRLF;
        $| = 1;
    }
    $head .= "Content-type: text/html; charset=$CHARSET". $CRLF;
    $head .= $CRLF;
    if($mod_perl_support == 1){
        $| = 1; binmode(STDOUT);
        my $r = Apache->request();
        $r->send_cgi_header($head);
    } else {
        print $head;
    }
    1;
}

sub encode_ctrl {
    my $s = shift;
    $s =~ tr/\x09\x0a\x0c\x0d\x22\x26/\x11\x12\x13\x14\x15\x16/;
    $s;
}

sub decode_ctrl {
    my $s = shift;
    $s =~ tr/\x11\x12\x13\x14\x15\x16/\x09\x0a\x0c\x0d\x22\x26/;
    $s;
}

sub meta_encode {
    my $s = shift;
    $s =~ s/</&lt;/go;
    $s =~ s/>/&gt;/go;
    $s =~ s/"/&quot;/go;
    $s;
}

sub meta_decode {
    my $s = shift;
    $s =~ s/&lt;/</go;
    $s =~ s/&gt;/>/go;
    $s =~ s/&quot;/"/go;
    $s;
}

sub check_logs {
    if($CONF{CONTINUE} || $CONF{SEND_TEST} || $CONF{REPLY_TEST}){
        return 1;
    }
    my($file, $ctrl) = @_;
    my($log, $id, $status, $time, $addr, $host, $agent);
    my $now = time();
    my $fh = Symbol::gensym();
    if(open($fh, "< $HLOG_DIR/$file")){
        while (<$fh>){
            chomp;
            ($id, $status, $time, $addr, $host, $agent) = split(/\t/);
            if($id eq $CONF{CONFCTRL} || ($addr eq $REMOTE_ADDR && $host eq $REMOTE_HOST && $agent eq $USER_AGENT)){
                $log = 1; last;
            }
        }
        close $fh;
    }
    if($CONF{CONFIRM}){
        if($log && $status eq 'E'){
            if($CONF{DENY_TIME} > 0 && $time > $now - $CONF{DENY_TIME} * 60){
                error('09');
            }
        }
        return 1;
    }
    if($log){
        if($status eq 'E'){
            if($CONF{REQUIRE_CONFIRM}){
                error('08');
            }
            if($CONF{DENY_TIME} > 0 && $time > $now - $CONF{DENY_TIME} * 60){
                error('09');
            }
        } else {
            if($CONF{MAX_WAIT} > 0 && $time < $now - $CONF{MAX_WAIT} * 60){
                error('07');
            }
        }
    } else {
        if($CONF{REQUIRE_CONFIRM}){
            error('08');
        }
        if($CONF{CONFCTRL}){
            my($t, $p, $r) = $CONF{CONFCTRL} =~ /^(.+?)(.{5})(.{5})$/o;
            $time = $t + $p * 8 + $r * 7;
            if($time > $now || ($CONF{MAX_WAIT} > 0 && $time < $now - $CONF{MAX_WAIT} * 60)){
                error('07');
            }
        }
    }
    1;
}

sub write_conf {
    my($status, $ctrl, $file) = @_;
    my $temp = join('.', time(), $$, $temp_file_index++, 'temp');
    my $old = Symbol::gensym();
    my $new = Symbol::gensym();
    my $i = 1;
    open ($new, "> $HLOG_DIR/$temp") or return undef;
    print $new join("\t");
    if(open($old, "< $HLOG_DIR/$file")){
        while(<$old>){
            last if(++$i > 0);
            print $new $_;
        }
        close $old;
    }
    close $new;
    unless(rename_file($HLOG_DIR, $temp, $file)){
        unlink("$HLOG_DIR/$temp");
        return undef;
    }
    1;
}

sub set_log_file {
    my $file = index($FORM_URL, '?') >= 0 ? "" : $FORM_URL;
    if($file ne ""){
        my $home = $HOME_URL; $home =~ s/(\W)/\\$1/go;
        $file =~ s/^(.*?)$home//;
        $file =~ s/\W/_/go;
        $file =~ s/[_]+/_/go;
        $file =~ s/_[^_]*$//o;
    }
    $file ||= join('.', $FORM_NAME || 'default', 'form');
    my($p, $r) = ($$, int(rand(32767)));
    my $ctrl = join('', time() - $p * 8 - $r * 7, sprintf("%05d%05d", $p, $r));
    return ($file, $ctrl);
}

sub file_lock {
    my $file = ($TMPL_PLACE == 0 || $DATA_DIR_CTRL == 2) ? "" : shift;
    if($file eq ""){
        $file = $FORM_NAME || 'default';
    }
    $file .= '.lock';
    my $i = 0;
    no integer;
    while ($i++ < 10){
        if(mkdir("$HLOG_DIR/$file", 0777)){
            $CONF{LOCK_FILE} = $file;
            last;
        } elsif((-M "$HLOG_DIR/$file") > 0.0035){
            next if rmdir("$HLOG_DIR/$file");
        }
        sleep(1);
    }
    return $CONF{LOCK_FILE};
    use integer;
}

sub file_unlock {
    if(my $file = delete $CONF{LOCK_FILE}){
        rmdir("$HLOG_DIR/$file");
    }
}

sub rename_file {
    my($dir, $from, $to) = @_;
    if($^O =~ /^(MS)?Win/oi){
        $dir = get_full_path($dir);
    }
    rename("$dir/$from", "$dir/$to");
}

sub get_full_path {
    my $dir = shift;
    if($dir =~ m!^([A-Za-z]:|[/:\\])!o){
        return $dir;
    }
    my $path = get_script_path($ENV{'SCRIPT_FILENAME'} || $0);
    pos($dir) = 0;
    while ($dir =~ /\.\./go){
        $path =~ s!/[^/:]+$!!o;
    }
    $dir =~ s!^[./]+!!o;
    return $dir ? join('/', $path, $dir) : $path;
}

sub get_script_path {
    (my $s = shift) =~ s!\\!/!go;
    if($s =~ m![/:]!o){ $s =~ s!(.*?)[/]*[^/:]+$!$1!o; } else { $s = '.'; }
    $s;
}

sub set_receipt {
    my $file = $CONF{RCP_SAVE_FILE};
    if($DATA_DIR_CTRL > 0){
        $file =~ s!^[%./:~\\]+!!go;
    }
    if($DATA_DIR_CTRL == 2){
        $file = join('/', $DATA_DIR, $FORM_NAME, $file);
    } elsif($file !~ m!^(?:/|[a-zA-Z]:|\\\\)!o){
        $file = trans2path($file);
    }
    my $num = 0;
    my $fh = Symbol::gensym();
    if(open($fh, "< $file")){
        $_ = <$fh>;
        close($fh);
        if(/^(\d+),/o){ $num = $1; }
    }
    open($fh, "> $file") or error('91');
    print $fh join(',', ++$num, $SYS{DATE}, $SYS{TIME});
    close($fh);
    return join('-', $CONF{RCP_PREFIX}, sprintf("%07d", $num));
}

sub create_csv {
    my($debug) = @_;
    my $mode = $CONF{CSV_FILE_MODE};
    my $code = $CONF{CSV_FILE_CODE} || $PROGCODE;
    my($file, $line, $k, $v);
    foreach (@{ $CONF{CSV_ITEM_ORDER} }){
        s/ *,$//o;
        foreach $k (split(/ *, */)){
            $v = ($k =~ /^\$(SYS|ENV)\{(.+?)\}$/o) ? ${$1}{$2} : $FORM{$k};
            $v =~ s/\n//go;
            $v =~ s/"/""/go;
            $line .= qq("$v",);
        }
    }
    jcode::convert(\$line, $code, $PROGCODE) if $code ne $PROGCODE;
    unless($debug){
        if($mode > 1){
            $file = $CONF{CSV_MULTI_FILE} == 1 ? join('', $SYS{YEAR}, $SYS{MONTH}, '.csv') : $CONF{CSV_SAVE_FILE};
            $file =~ s!^[%./:~\\]+!!go if $DATA_DIR_CTRL > 0;
            $file = join('.', $FORM_NAME, 'csv') if $file eq "";
            if($DATA_DIR_CTRL == 2){
                $file = join('/', $DATA_DIR, $FORM_NAME, $file);
            } elsif($file !~ m!^(?:/|[a-zA-Z]:|\\\\)!o){
                $file = trans2path($file);
            }
            my $fh = Symbol::gensym();
            open($fh, ">> $file") or error('91');
            seek($fh, 0, 2);
            print $fh $line, "\n";
            close $fh;
        }
        return () if $mode == 2;
    }
    delete_temp();
    $v = 10;
   TEMP_LOOP: {
        $file = join('.', time, $$, $temp_file_index++, 0, 'csv');
        if(-e "$ATTACH_DIR/$file"){
            --$v > 0 ? redo TEMP_LOOP : error('91');
        }
    }
    my $fh = Symbol::gensym();
    open($fh, "> $ATTACH_DIR/$file") or error('91');
    print $fh $line, "\n";
    close $fh;
    return ($file, join('', $SYS{YEAR}, $SYS{MONTH}, $SYS{DAY}, $SYS{HOUR}, $SYS{MIN}, $SYS{SEC}, '.csv'));
}

sub sendmail {
    my $rcpt = shift;
    my($text, $html, $from, $to, $cc, $bcc, $subject);
    my(@header, @text_body, @html_body, %attach);
    if($rcpt eq 'mailto'){
        $text = $CONF{SEND_MAIL_TEXT};
        $html = $CONF{SEND_MAIL_HTML};
        if($CONF{SEND_MAIL_FROM} || $CONF{REPLY_ITEM} eq ""){
            $from = $CONF{MAIL_FROM};
        } else {
            $from = $FORM{$CONF{REPLY_ITEM}} || $CONF{MAIL_FROM};
        }
        $to  = $CONF{MAIL_TO};
        $cc  = $CONF{MAIL_CC};
        $bcc = $CONF{MAIL_BCC};
        if($FORM{'_attach_file'}){
            my @name = split(/,/, $FORM{'_attach_file'});
            my @file = split(/,/, $FORM{'_attach_temp'});
            for(my $i = $[; $i < @file; $i++){
                $attach{ $name[$i] } = join('/', $ATTACH_DIR, $file[$i]);
            }
        }
        if($CONF{CSV_FILE_MODE} > 0 && $FORM_NAME ne ""){
            my($file, $name) = create_csv();
            if($CONF{CSV_FILE_MODE} != 2){
                $attach{$name} = join('/', $ATTACH_DIR, $file);
            }
        }
    } else {
        $text = $CONF{REPLY_MAIL_TEXT};
        $html = $CONF{REPLY_MAIL_HTML};
        $from = $CONF{MAIL_FROM};
        $to   = $FORM{$CONF{REPLY_ITEM}};
    }
    edit_header(\@header);
    if($text eq "" && $html eq ""){
        edit_bodies('plain', undef, \@text_body);
    } else {
        if($text ne ""){
            edit_bodies('plain', $text, \@text_body);
            if($text_body[0] =~ /^Subject:\s*(.+?)\s*$/oi){
                chomp($subject = $1);
                shift(@text_body);
            }
        }
        if($html ne ""){
            edit_bodies('html', $html, \@html_body);
            if($html_body[0] =~ /^Subject:\s*(.+?)\s*$/oi){
                chomp($subject = $1);
                shift(@html_body);
            }
        }
    }
    $subject ||= $CONF{SUBJECT};
    if($SENDMAIL_METHOD == 0){
        send_mail($from, $to, $cc, $bcc, $subject, \@header, \@text_body, \@html_body, \%attach) || error('80');
    } else {
        smtp_mail($from, $to, $cc, $bcc, $subject, \@header, \@text_body, \@html_body, \%attach) || error('80');
    }
    1;
}

sub send_mail {
    my($from, $to, $cc, $bcc, $subject, $header, $text, $html, $attach) = @_;
   #-----------------#
    require Sendmail;
   #-----------------#
    my $mail = Sendmail->new($SENDMAIL) || return undef;
    my %request = (
        sender  => $CONF{MAIL_SENDER},
        from    => $from,
        to      => $to,
        cc      => $cc,
        bcc     => $bcc,
        subject => $subject,
        header  => $header,
        attach  => $attach,
        content => [],
        dotskip => 1,
    );
    if(@$text > 0){
        push(@{ $request{content} },
            { type    => 'text/plain',
              message => $text,
            }
        );
    }
    if(@$html > 0){
        push(@{ $request{content} },
            { type    => 'text/html',
              message => $html,
            }
        );
    }
    $mail->request(%request);
}

sub smtp_mail {
    my($from, $to, $cc, $bcc, $subject, $header, $text, $html, $attach) = @_;
   #-----------------#
    require SMTP;
   #-----------------#
    my %smtp_parm = (
        host   => $SMTPHOST,
        port   => $SMTPPORT,
        domain => $CLIENTDN,
    );
    if(keys %POP3_PARAM){
        $smtp_parm{'POP_before_SMTP'} = \%POP3_PARAM;
    } elsif(keys %SMTP_AUTH){
        $smtp_parm{'SMTP_AUTH'} = \%SMTP_AUTH;
    }
    my $smtp = SMTP->new(%smtp_parm) || return undef;
    my %request = (
        sender  => $CONF{MAIL_SENDER},
        from    => $from,
        to      => $to,
        cc      => $cc,
        bcc     => $bcc,
        subject => $subject,
        header  => $header,
        attach  => $attach,
        content => [],
    );
    if(@$text > 0){
        push(@{ $request{content} },
            { type    => 'text/plain',
              message => $text,
            }
        );
    }
    if(@$html > 0){
        push(@{ $request{content} },
            { type    => 'text/html',
              message => $html,
            }
        );
    }
    $smtp->request(%request);
}

sub draw_debug_page {
    my(@bodies, $from, $to, $cc, $bcc, $subject, $ctype, $temp);
    my @temp = (); get_template("$CONF_DIR/debug.html", \@temp);
    my $code = $CONF{HTML_CODE};
    if($CONF{DELETE_CRLF}){
        foreach (@INPUT_ORDER){
            next unless defined $FORM{$_};
            $FORM{$_} =~ s/\n//go;
        }
    }
    if($CONF{REPLY_TEST}){
        if($CONF{NOT_REPLY_MAIL} || $CONF{REPLY_ITEM} eq "" || $FORM{ $CONF{REPLY_ITEM} } eq ""){
            error('92');
        }
        ($from, $to) = ($CONF{MAIL_FROM}, $FORM{ $CONF{REPLY_ITEM} });
        if($CONF{REPLY_MAIL_HTML}){
            ($temp, $ctype) = ($CONF{REPLY_MAIL_HTML}, 'html');
        } else {
            ($temp, $ctype) = ($CONF{REPLY_MAIL_TEXT}, 'plain');
        }
    } else {
        if($CONF{SEND_MAIL_FROM} || $CONF{REPLY_ITEM} eq ""){
            $from = $CONF{MAIL_FROM};
        } else {
            $from = $FORM{$CONF{REPLY_ITEM}} || $CONF{MAIL_FROM};
        }
        ($to, $cc, $bcc) = ($CONF{MAIL_TO}, $CONF{MAIL_CC}, $CONF{MAIL_BCC});
        if($CONF{SEND_MAIL_HTML}){
            ($temp, $ctype) = ($CONF{SEND_MAIL_HTML}, 'html');
        } else {
            ($temp, $ctype) = ($CONF{SEND_MAIL_TEXT}, 'plain');
        }
    }
    my($reply, $errto) = ($CONF{MAIL_REPLY}, $CONF{MAIL_ERROR});
    http_header();
    foreach (@temp){
        if(/^\<\!\-\-\-\s+\%DUMP_PART\%\s+\-\-/o){
            dump_all('plain');
            auto_fold_values();
            edit_bodies('plain', $temp, \@bodies);
            if($bodies[0] =~ /^Subject: *(.+?) *$/oi){
                chomp($subject = $1); shift(@bodies);
            }
        } elsif(/^\<\!\-\-\-\s+\%HEAD_PART\%\s+\-\-/o){
            $subject ||= $CONF{SUBJECT} || '(no subject)';
            draw_debug_part('head', $from, $to, $cc, $bcc, $reply, $errto, $subject, $ctype, \@bodies);
        } elsif(/^\<\!\-\-\-\s+\%BODY_PART\%\s+\-\-/o){
            draw_debug_part('body', $from, $to, $cc, $bcc, $reply, $errto, $subject, $ctype, \@bodies);
        } elsif(/^\<\!\-\-\-\s+\%FILE_PART\%\s+\-\-/o){
            unless(defined $CONF{REPLY_TEST}){
                draw_debug_part('file');
            }
        } else {
            s/\$\{(.+?)\}/${$1}/ego;
            jcode::convert(\$_, $code, $PROGCODE) if $code ne $PROGCODE;
            print $_;
        }
    }
}

sub draw_debug_part {
    my($part, $from, $to, $cc, $bcc, $reply, $errto, $subject, $ctype, $bodies) = @_;
    my $code = $CONF{HTML_CODE};
    if($part eq 'head'){
        my @header = ("From: $from");
        $to  =~ s/\s*[,;]\s*/,\n /go; push(@header, "To: $to")   if $to;
        $cc  =~ s/\s*[,;]\s*/,\n /go; push(@header, "Cc: $cc")   if $cc;
        $bcc =~ s/\s*[,;]\s*/,\n /go; push(@header, "Bcc: $bcc") if $bcc;
        push(@header, "Reply-To: $reply")  if $reply;
        push(@header, "Errors-To: $errto") if $errto;
        push(@header, "Subject: $subject");
        push(@header, "X-REMOTO-ADDR: $REMOTE_ADDR");
        push(@header, "X-REMOTE-HOST: $REMOTE_HOST") if $REMOTE_HOST;
        push(@header, "X-HTTP-USER-AGENT: $USER_AGENT");
        push(@header, "X-Mailer: Formdecode Plus $VERSION [ja]");
        print qq(<span style="font-family:monospace">);
        foreach (@header){
            jcode::convert(\$_, $code, $PROGCODE) if $code ne $PROGCODE;
            print meta_encode($_), "<br>\n";
        }
        print qq(</span>\n);
    } elsif($part eq 'body'){
        if($ctype eq 'plain'){
            print qq(<pre>);
            foreach (@{$bodies}){
                jcode::convert(\$_, $code, $PROGCODE) if $code ne $PROGCODE;
                print meta_encode($_);
            }
            print qq(</pre>\n);
        } else {
            my $skip = 1;
            foreach (@{$bodies}){
                if(m!<body!oi){
                    $skip = 0;
                } elsif(m!</body>!oi){
                    $skip = 1;
                } elsif($skip == 0){
                    jcode::convert(\$_, $code, $PROGCODE) if $code ne $PROGCODE;
                    print $_;
                }
            }
        }
    } elsif($part eq 'file'){
        if($FORM{'_attach_file'}){
            my @file = split(/,/, $FORM{'_attach_file'});
            my @size = split(/,/, $FORM{'_attach_size'});
            my @temp = split(/,/, $FORM{'_attach_temp'});
            my $i = 0;
            foreach (@file){
                print qq!<a href="$ATTACH_URL/$temp[$i]" target="_blank">!;
                print qq!<img src="$SYSTEM_IMAGE/attach.gif" width="32" height="32" border="0"> $_</a> ($size[$i]bytes)\n!;
                $i++;
            }
        }
        if($CONF{CSV_FILE_MODE} > 0 && $FORM_NAME){
            my($file, $name) = ($FORM{'_csv_send_file'}, $FORM{'_csv_send_name'});
            if($file eq ""){
                ($file, $name) = create_csv(1);
                print qq(<input type="hidden" name="_csv_send_file" value="$file">\n);
                print qq(<input type="hidden" name="_csv_send_name" value="$name">\n);
            }
            print qq!<a href="$ATTACH_URL/$file" target="_blank">!;
            print qq!<img src="$SYSTEM_IMAGE/csv.gif" width="32" height="32" border="0"> $name</a>\n!;
        }
    }
}

sub exit_proc {
    file_unlock();
    undef %SYS;
    undef %CONF;
    undef %FORM;
    undef @INPUT_ORDER;
    undef %AUTO_VALUES;
    exit();
}

sub error {
    my $error = shift;
    if(@_){
        foreach (@_){
            if(defined $CONF{ITEM_NAME}{$_}){
                $ERROR_ITEMS .= $CONF{ITEM_NAME}{$_} .', ';
            }
        }
        $ERROR_ITEMS =~ s/,\s*$//o;
        $ERROR_ITEMS = qq($ERROR_ITEMS);
    }
    $ERROR_MESSAGE = ($error !~ /^\d\d$/o) ? $error : ($ERROR_MESSAGES{$error} || $ERROR_MESSAGES{'99'});
    $ERROR_MESSAGE =~ s/\$(FORM|SYS)\{\s*(.+?)\s*\}/${$1}{$2}/ego;
    my $file = $CONF{ERROR_TMPL} ? trans2path($CONF{ERROR_TMPL}) : join('/', $CONF_DIR, 'error.html');
    draw_page($file);
    exit_proc();
}
